<template>
  <div>
    <el-form ref="queryForm" :model="searchForm" label-width="0" inline>
      <el-form-item>
        <el-input
          v-model="searchForm.name"
          placeholder="请输入名称"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button @click="handleQuery">搜索</el-button>
        <el-button @click="resetQuery">重置</el-button>
        <el-button type="primary" @click="openForm('create', null)">新增</el-button>
      </el-form-item>
    </el-form>
    <el-table v-loading="loading" :data="list" row-key="id" :tree-props="{ children: 'children' }">
      <el-table-column prop="name" label="分类名称" />
      <el-table-column prop="sort" label="排序" width="100px" />
      <el-table-column prop="remark" label="备注" />
      <el-table-column label="状态" min-width="150" prop="status">
        <template #default="scope">
          <dict-tag :type="DICT_TYPE.COMMON_STATUS" :value="scope.row.status" />
        </template>
      </el-table-column>
      <el-table-column
        label="创建时间"
        prop="createTime"
        width="180px"
        :formatter="dateFormatter"
      />
      <el-table-column label="操作" width="150px">
        <template #default="scope">
          <el-button
            type="primary"
            style="padding: 0px"
            text
            @click="openForm('update', scope.row)"
          >
            修改
          </el-button>
          <el-button
            type="primary"
            style="padding: 0px"
            text
            @click="openForm('createChildren', scope.row)"
          >
            新增
          </el-button>
          <el-button type="danger" style="padding: 0px" text @click="handleDelete(scope.row.id)">
            删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <Pagination
      v-model:limit="searchForm.pageSize"
      v-model:page="searchForm.pageNo"
      :total="total"
      @pagination="handleQuery"
    />

    <DialogCategory ref="categoryDialog" @success="handleQuery" />
  </div>
</template>

<script setup name="CategorySet">
import * as ProductCategoryApi from '@/api/mall/product/category'
import { handleTree } from '@/utils/tree'
import DialogCategory from './DialogCategory.vue'
import { dateFormatter } from '@/utils/formatTime'
import { DICT_TYPE } from '@/utils/dict'

const message = useMessage() // 消息弹窗
const { t } = useI18n() // 国际化

const searchForm = ref({
  name: undefined
})

const total = ref(0)
const categoryDialog = ref()
const list = ref([])
const loading = ref(false)

function handleQuery() {
  getList()
}
function resetQuery() {
  searchForm.value = {
    name: undefined
  }
  getList()
}

async function getList() {
  loading.value = true
  try {
    const data = await ProductCategoryApi.getCategoryList(searchForm.value)
    list.value = handleTree(data, 'id', 'parentId')
  } finally {
    loading.value = false
  }
}

function openForm(type, info) {
  categoryDialog.value.open(type, info)
}

async function handleDelete(id) {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await ProductCategoryApi.deleteCategory(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}

handleQuery()
</script>

<style lang="scss" scoped></style>
